﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=10.7
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim WiFiConnect1 As WiFiConnect
End Sub

Sub Service_Create

End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	
	WiFiConnect1.Initialize
	
	If WiFiConnect1.getWifiState <> WiFiConnect1.WIFI_STATE_ENABLED Then
		WiFiConnect1.setWifiEnabled(True)
		Sleep(10000)
	End If
	
	scan
End Sub

Sub scan

	Dim strSplit() As String
	Dim strSplit2() As String
	Dim strSSID As String
	Dim strBSSID As String
	Dim strSECURITY As String
	Dim strLEVEL As String
	Dim strFREQUENCY As String
	Dim list1 As List
	Dim listConfigured As List
	Dim sSignal As String
	'	Dim listState As List
	Dim sState As String
	Dim sRank As String
	Dim listNetwork As List
	
	Try
		listNetwork.Initialize
		
		list1.Initialize
		listConfigured.Initialize
		'	listState.Initialize
		
		
		If WiFiConnect1.getWifiState <> WiFiConnect1.WIFI_STATE_ENABLED Then
			WiFiConnect1.setWifiEnabled(True)
		End If
		
		WiFiConnect1.startScan
		
		list1 = WiFiConnect1.getScanResults
		
		listConfigured = WiFiConnect1.getConfiguredNetworks
		

		'CLVWifi.Clear
		'ResultsBkp.Clear
		'	listState.Clear
		
		For i = 0 To list1.Size -1
			'		Msgbox(list1.Get(i), "")
			strSSID = ""
			strSECURITY = ""
			
			strSplit = Regex.Split(",", list1.Get(i))
			For j = 0 To strSplit.Length -1
				strSplit2 = Regex.Split(": ", strSplit(j))
				If strSplit2.Length = 2 Then
					If strSplit2(0).Contains("BSSID") Then
						strBSSID = strSplit2(1).Trim
					Else If strSplit2(0).Contains("SSID") Then
						strSSID = strSplit2(1).Trim
					Else If strSplit2(0).Contains("capabilities") Then
						strSECURITY = strSplit2(1).Trim
					Else If strSplit2(0).Contains("level") Then
						strLEVEL = strSplit2(1).Trim
					Else If strSplit2(0).Contains("frequency") Then
						strFREQUENCY = strSplit2(1).Trim
					End If
				End If
			Next
			
			If strSECURITY.Contains("WPA2") Then
				strSECURITY = "WPA2"
			Else If strSECURITY.Contains("WPA") Then
				strSECURITY = "WPA"
			Else If strSECURITY.Contains("WEP") Then
				strSECURITY = "WEP"
			Else
				strSECURITY = "OPEN"
			End If
			
			If strLEVEL >= -30 Then
				sSignal = "Excellent"
			Else If strLEVEL >= -67 Then
				sSignal = "Très Bon"
			Else If strLEVEL >= -70 Then
				sSignal = "Bon"
			Else If strLEVEL >= -80 Then
				sSignal = "Mauvais"
			Else
				sSignal = "Très Mauvais"
			End If
			
			sState = ""
			sRank = 0
			
			For k = 0 To listConfigured.Size -1
				'			Msgbox(listConfigured.Get(k), "")
				Dim strCont As String = listConfigured.Get(k)
				If strCont.Contains(Chr(34) & strSSID & Chr(34)) Then
					sRank = strCont.SubString2(strCont.IndexOf("ID: ")+4, _
												strCont.IndexOf("SSID: "))
					'				Msgbox(sRank, "")
					If IsNumber(sRank) = False Then
						sRank = 0
					End If
				
					If strCont.Contains("DSBLE") Then
						sState = "Saved"
					Else
						sState = "Connected"
					End If
				End If
			Next
			If strSSID<>"" Then
				listNetwork.Add(strSSID & " -- " & "Qualité du Signal: " & sSignal )
			End If
			
			'" (" & strLEVEL & " dBm)")
			'CLVWifi.AddTextItem(strSSID & " [" & strBSSID & "]", "Saved, Signal: " & sSignal & _
								'" (" & strLEVEL & " dBm)")
'			ListView1.TwoLinesLayout.Label.TextSize=15
'			'If strSSID.Contains("TP-LINK") Then
'				
'			If sState = "Saved" Then
'					
'				ListView1.AddTwoLines2(strSSID & " [" & strBSSID & "]", _
'								"Saved, Signal: " & sSignal & _
'								" (" & strLEVEL & " dBm)", i)
'			Else If sState = "Connected" Then
'				ListView1.AddTwoLines2(strSSID & " [" & strBSSID & "]", _
'								"Connected, Signal: " & sSignal & _
'								" (" & strLEVEL & " dBm)", i)
'			Else
'
'				ListView1.AddTwoLines2(strSSID & " [" & strBSSID & "]", _
'								"Security: " & strSECURITY & _
'								", Signal: " & sSignal & _
'								" (" & strLEVEL & " dBm)", i)
'			End If
'			'End If
'			
'			
'			ResultsBkp.Add(strSSID & "," & _
'							strSECURITY & "," & _
'							strLEVEL & "," & _
'							strFREQUENCY & "," & _
'							sState & "," & _
'							sRank)
		Next
		
		CallSub2(Main,"CallBackWifi",listNetwork)
		StopService(Me)
	Catch
		Log(LastException)
	End Try

End Sub

Sub Service_Destroy

End Sub
